; Dsassemblage de SPY3.BIN
; Interface Mididak de Logimus

; Appel par le BASIC avec un EXEC&HB000

; Dfinitions

PUTCH           EQU    $E803
KTSTH           EQU    $E809

COLN            EQU    $6020
IRQPT           EQU    $6021

LF              EQU    $0A
VT              EQU    $0B
FF              EQU    $0C
CR              EQU    $0D
ESC             EQU    $1B
RS              EQU    $1E
SPACE           EQU    $20

MIDI.CTRL       EQU    $E7F2
MIDI.STAT       EQU    MIDI.CTRL
MIDI.RX         EQU    $E7F3
MIDI.TX         EQU    MIDI.RX

MIDI.RXFULL     EQU    $01
MIDI.TXEMPTY    EQU    $02
MIDI.RXIRQ      EQU    $80

NOTE_ON         EQU    $90
NOTE_OFF        EQU    $80

BEGBUF          EQU    $A800
ENDBUF          EQU    $AFD0


; Dbut du code ici
                ORG    $B000

Start:
B000 7EB1E9     JMP    Start2              

----
; Code mort - zone de variable
; B003 B6E7F2     LDA    $E7F2              
; B006 8401       ANDA   #$01                   
; B008 2704       BEQ    $B00E              
; B00A B6E7F3     LDA    $E7F3              
; B00D 39         RTS         
; B00E BDE809     JSR    $E809              
; (EVT_TBL)
; B021 B0         FCB    $80  
----
                
DataZone:
CaptureSize:                
B003            RMB    2       ; Taille de ce qui a t dj captur

BufFullFlag:
B005            RMB    1       ; Mis  1 quand le buffer est plein

ErrorFlag:
B006            RMB    1       ; Mis  1 quand erreur de transmission MIDI

TmpChar1:
B007            RMB    1       ; Pour sauver l'octet reu

TmpChar2:
B008            RMB    1       ; Pour sauver l'octet  traiter

PayloadSize:
B009            RMB    1       ; Taille de ce qui suit l'entte

ProdPtr:
B00A            RMB    2       ; Pointeur production

EndOfBuf:
B00C            RMB    2       ; Fin du buffer

ConsPtr:
B00E            RMB    2       ; Pointeur consommation

Unused1:
B010            RMB    1       ; Initialis mais pas utilis

; Types d'vnements  surveiller
EVT_TBL:
B011            FCB    $80,2   ; Note off, suivi de 2 paramtres
                FCB    $90,2   ; Note on, suivi de 2 paramtres
                FCB    $A0,2   ; Aftertouch, suivi de 2 paramtres
                FCB    $B0,2   ; Continuous controller, suivi de 2 paramtres
                FCB    $C0,1   ; Patch change, suivi de 1 paramtre
                FCB    $D0,1   ; Channel pressure, suivi de 1 paramtre
                FCB    $E0,2   ; Pitch bend, suivi de 2 paramtres
                FCB    $F0,0   ; Non-musical commands

ET_END          EQU    * 

FoundMsgFlag:
B021            RMB    1       ; Mis  1 quand un message est reconnu

; Fin de zone de variables     

; Prologue
; Initialise les variables et met en place la routine d'interruption
InitVarIRQ:       
B022 8603       LDA    #$03            ; Reset contrleur        
B024 B7E7F2     STA    MIDI.CTRL              
B027 1A10       ORCC   #$10            ; Pas d'interruptions        
B029 7FB003     CLR    CaptureSize              
B02C 7FB004     CLR    CaptureSize+1              
B02F 7FB005     CLR    BufFullFlag              
B032 7FB006     CLR    ErrorFlag              
B035 7FB009     CLR    PayloadSize              
B038 7FB021     CLR    FoundMsgFlag              
B03B CCB072     LDD    #IRQ_Routine            
B03E FD6021     STD    IRQPT           ; Installe la routine IRQ        
B041 8EA800     LDX    #BEGBUF         ; Initialise pointeur production        
B044 BFB00A     STX    ProdPtr              
B047 8EAFD0     LDX    #ENDBUF    
B04A BFB00C     STX    EndOfBuf              
B04D 8EA800     LDX    #BEGBUF         ; Initialise pointeur consommation        
B050 BFB00E     STX    ConsPtr              
B053 8695       LDA    #$95            ; Protocole MIDI avec interruptions        
B055 B7E7F2     STA    MIDI.CTRL          
B058 C61B       LDB    #ESC               
B05A BDB124     JSR    FastDispChar              
B05D C66B       LDB    #$6B            ; Mode page        
B05F BDB124     JSR    FastDispChar              
B062 7FB010     CLR    Unused1              
B065 39         RTS                       

; Routine de nettoyage du buffer de rception
ClearBuf:
B066 8EA800     LDX    #BEGBUF             
B069 4F         CLRA
                                            
ClearBufLoop:
B06A A780       STA    ,X+                
B06C 8CAFD0     CMPX   #ENDBUF             
B06F 26F9       BNE    ClearBufLoop              
B071 39         RTS                       

; Routine d'interruption, appele  chaque IRQ
; Si l'IRQ a t gnre par l'interface MIDI, traite le caractre reu
; ou les erreurs de transmission ventuelles
IRQ_Routine:
B072 B6E7F2     LDA    MIDI.STAT              
B075 F6E7F3     LDB    MIDI.RX              
B078 F7B007     STB    TmpChar1        ; Sauve l'octet lu       
B07B 1F89       TFR    A,B                
B07D 8480       ANDA   #MIDI.RXIRQ               
B07F 10270072   LBEQ   EndOfIRQ        ; Ca ne vient pas de l'interface MIDI
                                
B083 1F98       TFR    B,A                
B085 8401       ANDA   #MIDI.RXFULL               
B087 10270053   LBEQ   IRQ_NotData     ; Buffer vide, le souci est ailleurs       

B08B B6B007     LDA    TmpChar1        ; Alors, cet octet lu ... ?      
B08E 84F0       ANDA   #$F0               
B090 102A0013   LBPL   NotEvt          ; Pas un vnement MIDI       

B094 7FB021     CLR    FoundMsgFlag              
B097 8EB011     LDX    #EVT_TBL        ; Compare avec vnements  surveiller

SeekEvtLoop:       
B09A A181       CMPA   ,X++               
B09C 10270036   LBEQ   FoundEvt        ; Trouv dans la table       

B0A0 8CB021     CMPX   #ET_END         ; Fin de table       
B0A3 1026FFF3   LBNE   SeekEvtLoop              

NotEvt:
B0A7 B6B021     LDA    FoundMsgFlag              
B0AA 10260047   LBNE   EndOfIRQ              

B0AE B6B007     LDA    TmpChar1        ; Sauve l'octet dans le buffer        
B0B1 BEB00A     LDX    ProdPtr              
B0B4 A780       STA    ,X+                
B0B6 BFB00A     STX    ProdPtr         ; Et met  jour le pointeur production        
B0B9 3420       PSHS   Y                  
B0BB 10BEB003   LDY    CaptureSize              
B0BF 3121       LEAY   1,Y              
B0C1 10BFB003   STY    CaptureSize              
B0C5 3520       PULS   Y                  
B0C7 8CAFD0     CMPX   #ENDBUF             
B0CA 10260027   LBNE   EndOfIRQ              

B0CE 8601       LDA    #1               
B0D0 B7B005     STA    BufFullFlag              
B0D3 7EB0F5     JMP    EndOfIRQ              

FoundEvt:
B0D6 8601       LDA    #1               
B0D8 B7B021     STA    FoundMsgFlag              
B0DB 7EB0F5     JMP    EndOfIRQ              

IRQ_NotData:
B0DE 1F98       TFR    B,A                
B0E0 8402       ANDA   #$02            ; TX plein ?     
B0E2 2703       BEQ    IRQ_IsError     ; Non, c'est encore autre chose ...     

B0E4 7EB0F5     JMP    EndOfIRQ        ; Oui ? on s'en fiche ...     

IRQ_IsError:
B0E7 1F98       TFR    B,A                
B0E9 8470       ANDA   #$70            ; Erreur ?     
B0EB 2708       BEQ    EndOfIRQ        ; Non.
     
B0ED 8601       LDA    #1              ; Set le flag d'erreur     
B0EF B7B006     STA    ErrorFlag              
B0F2 7EB0F5     JMP    EndOfIRQ        ; Trs utile ...              

EndOfIRQ:
B0F5 3B         RTI                       

; Routine d'affichage d'un nombre hexa 8 bits
; Entre: A = octet  afficher
DispHex8:
B0F6 1F89       TFR    A,B                
B0F8 44         LSRA                      
B0F9 44         LSRA                      
B0FA 44         LSRA                      
B0FB 44         LSRA                      
B0FC BDB10F     JSR    ConvDigit       ; Chiffre suprieur       
B0FF 1E89       EXG    A,B                
B101 BDB124     JSR    FastDispChar              
B104 840F       ANDA   #$0F               
B106 BDB10F     JSR    ConvDigit       ; Chiffre infrieur       
B109 1E89       EXG    A,B                
B10B BDB124     JSR    FastDispChar              
B10E 39         RTS                
        
; Routine de conversion d'un chiffre hexa
; Entre: A = chiffre sur 4 bits infrieurs
; Sortie: A = caractre ASCII correspondant       
ConvDigit:       
B10F 810A       CMPA   #10               
B111 2403       BCC    ConvDigit_AF            

B113 8B30       ADDA   #'0               
B115 39         RTS                       

ConvDigit_AF:
B116 8B37       ADDA   #55               
B118 39         RTS                       

; Routine d'effacement cran et retour curseur en (0,0)
CLS_Home:
B119 C60C       LDB    #FF             ; CLS
B11B BDB124     JSR    FastDispChar              
B11E C61E       LDB    #RS             ; Home
B120 BDB124     JSR    FastDispChar              
B123 39         RTS                       

; Routine d'affichage "rapide"
; Si la machine est reconnue, appel direct  la sous-routine d'affichage
; sinon appel PUTCH standard
FastDispChar:
B124 3402       PSHS   A                  
B126 B6E804     LDA    $E804              
B129 81F2       CMPA   #$F2            ; Test type machine (T9000, TO7, TO7/70)
B12B 2709       BEQ    DispTO7              

B12D 81EC       CMPA   #$EC            ; Test type machine (TO9)
B12F 2713       BEQ    DispTO9              

B131 3502       PULS   A               ; Autre machine
B133 7EE803     JMP    PUTCH           ; Routine d'affichage standard

DispTO7:
B136 3502       PULS   A                  
B138 347F       PSHS   U,Y,X,DP,B,A,CC    
B13A BDF328     JSR    $F328              
B13D 8660       LDA    #$60               
B13F 1F8B       TFR    A,DP               
B141 7EF2BE     JMP    $F2BE              

DispTO9:
B144 3502       PULS   A                  
B146 347F       PSHS   U,Y,X,DP,B,A,CC    
B148 8660       LDA    #$60               
B14A 1F8B       TFR    A,DP               
B14C 7EED39     JMP    $ED39              

; Epilogue
; Nettoie et rinitialise tout avant de revenir au BASIC
CleanAll:
B14F 8603       LDA    #$03            ; Reset controleur        
B151 B7E7F2     STA    MIDI.CTRL              
B154 8615       LDA    #$15            ; lecture/criture sans interruption        
B156 B7E7F2     STA    MIDI.CTRL              
B159 1A10       ORCC   #$10            ; Masque les interruptions        
B15B 8EE844     LDX    #$E844          ; (RTI)        
B15E BF6021     STX    IRQPT           ; Restaure la routine IRQ de base        
B161 C61B       LDB    #ESC               
B163 BDB124     JSR    FaspDispChar              
B166 C66A       LDB    #$6A            ; Scroll rapide   
B168 BDB124     JSR    FastDispChar            
B16B 39         RTS                       

; Routine de traitement d'un octet reu
; Dtection d'un message MIDI et affichage en consquence
; Entre: A = octet  traiter
ProcessByte:
B16C B7B008     STA    TmpChar2        ; Sauve l'octet  traiter        
B16F B66020     LDA    COLN              
B172 8124       CMPA   #36             ; Colonne 36 dj ?  
B174 2503       BCS    SkipSep1             

B176 17003F     LBSR   DispSep
              
SkipSep1:              
B179 B6B008     LDA    TmpChar2        ; Recharge l'octet  traiter        
B17C 84F0       ANDA   #$F0            ; Masque pour commandes MIDI   
B17E 8190       CMPA   #NOTE_ON               
B180 2613       BNE    Not90           ; Pas un Note On
        
B182 C64F       LDB    #'O               
B184 BDB124     JSR    FastDispChar              
B187 C64E       LDB    #'N

NoteSeq:               
B189 BDB124     JSR    FastDispChar              
B18C BDB1E3     JSR    DispSpace              
B18F 8602       LDA    #2              ; Deux octets de plus doivent suivre        
B191 B7B009     STA    PayloadSize              
B194 39         RTS                       

Not90:
B195 8180       CMPA   #NOTE_OFF               
B197 260D       BNE    Not80           ; Pas un Note Off non plus        
B199 C64F       LDB    #'O               
B19B BDB124     JSR    FastDispChar              
B19E C646       LDB    #'F               
B1A0 BDB124     JSR    FastDispChar              
B1A3 7EB189     JMP    NoteSeq              

Not80:
B1A6 B6B008     LDA    TmpChar2        ; On affiche la valeur hexa        
B1A9 BDB0F6     JSR    DispHex8              
B1AC BDB1E3     JSR    DispSpace              
B1AF 7AB009     DEC    PayloadSize              
B1B2 2603       BNE    SkipSep2              

B1B4 BDB1B8     JSR    DispSep

SkipSep2:              
B1B7 39         RTS                       

; Routine d'affichage d'un sparateur
DispSep:
B1B8 BDB1D8     JSR    DispCRLF              
B1BB BDB1D8     JSR    DispCRLF              
B1BE 8625       LDA    #37             ; Affiche 37 espaces   
B1C0 C620       LDB    #SPACE               

DispSepLoop:
B1C2 BDB124     JSR    FastDispChar              
B1C5 4A         DECA                      
B1C6 26FA       BNE    DispSepLoop              

B1C8 C60B       LDB    #VT               
B1CA BDB124     JSR    FastDispChar              
B1CD C60D       LDB    #CR               
B1CF BDB124     JSR    FastDispChar              
B1D2 C60D       LDB    #CR               
B1D4 BDB124     JSR    FastDispChar              
B1D7 39         RTS                       

; Routine "Retour  la ligne"
DispCRLF:
B1D8 C60D       LDB    #CR               
B1DA BDB124     JSR    FastDispChar              
B1DD C60A       LDB    #LF               
B1DF BDB124     JSR    FastDispChar              
B1E2 39         RTS                       

; Routine "Espace"
DispSpace:
B1E3 C620       LDB    #SPACE               
B1E5 BDB124     JSR    FastDispChar              
B1E8 39         RTS                       

; Code principal ici
Start2:
B1E9 BDB022     JSR    InitVarIRQ      ; Initialise variables et routine IRQ          
B1EC BDB066     JSR    ClearBuf        ; Nettoie le buffer de rception              
B1EF BDB119     JSR    CLS_Home        ; Prpare l'cran              
B1F2 1CEF       ANDCC  #$EF            ; Active les interruptions

S2_Loop:     
B1F4 BDE809     JSR    KTSTH     
B1F7 2518       BCS    S2_End          ; Touche presse ?     

B1F9 B6B005     LDA    BufFullFlag     ; Buffer plein ?           
B1FC 2613       BNE    S2_End          ; -> STOP !      

B1FE BEB00E     LDX    ConsPtr              
B201 BCB00A     CMPX   ProdPtr         ; Buffer consomm ?     
B204 27EE       BEQ    S2_Loop            

B206 A680       LDA    ,X+             ; Octet suivant     
B208 BFB00E     STX    ConsPtr              
B20B BDB16C     JSR    ProcessByte     ; Interprte et affiche         
B20E 7EB1F4     JMP    S2_Loop              

S2_End:
B211 BDB14F     JSR    CleanAll        ; On ferme !     
B214 39         RTS                    ; Retour au BASIC                   


; Code mort, inutilis
;
; B215 02         ???                       
; B216 27F9       BEQ    $B211              
; B218 3502       PULS   A                  
; B21A B7E7F3     STA    $E7F3              
; B21D 39         RTS                       
; B21E BDB232     JSR    $B232              
; B221 B6B142     LDA    $B142              
; B224 847F       ANDA   #$7F               
; B226 BDB20F     JSR    $B20F              
; B229 39         RTS                       
; B22A BDB232     JSR    $B232              
; B22D 4F         CLRA                      
; B22E BDB20F     JSR    $B20F              
